﻿package 
{
	import flash.display.Sprite;
	import flash.events.Event;

	public class Fourmizer extends Sprite
	{
		private var quantity:Number = 80;
		private var dotNum:Number = 0;
		private var dots:Array = [];
		private var vitesseMax:Number = 1;
		private var vitesseRotation = Math.random() * 3;
		private var vitesseEloignement = Math.random() * 1;
		private var activeWidth:Number 	= Math.random()*(4,40);
		private var activeHeight:Number = Math.random()*(4,40);
		public function Fourmizer()
		{
			addEventListener(Event.ADDED_TO_STAGE, addedHandler);
		}

		private function addedHandler(e:Event):void
		{
			for (var i:Number = 0; i<quantity; i++)
			{
				addDot(Math.random()*stage.stageWidth,Math.random()*stage.stageHeight);
			}
			addEventListener(Event.ENTER_FRAME,enterHandler);
		}
		//ajout points
		private function addDot(x:Number,y:Number):void
		{
			
		
		
			dots[dotNum] = new Object();
			dots[dotNum].x = x;
			dots[dotNum].y = y;
			dots[dotNum].angle = Math.random() * 2 * Math.PI;
			dots[dotNum].v = Math.random() * vitesseMax;
			dots[dotNum].s = new Sprite();
			dots[dotNum].s.graphics.lineStyle(1,0x000000);
			dots[dotNum].s.graphics.beginFill(0xFFFFFF,1);
			dots[dotNum].s.graphics.drawCircle(0,0,Math.random()*(1,8));
			dots[dotNum].s.graphics.endFill();
			dots[dotNum].s.graphics.lineStyle(Math.random()*(1,4),0x000000,Math.random()*(10,40));
			dots[dotNum].s.graphics.moveTo(-10,-activeHeight/2);
			dots[dotNum].s.graphics.lineTo(-10,activeHeight/2); 
			dots[dotNum].s.graphics.endFill();
			dots[dotNum].s.graphics.lineStyle(Math.random()*(1,4),0x000000,Math.random()*(10,40));
			dots[dotNum].s.graphics.moveTo(10,-activeWidth/2);
			dots[dotNum].s.graphics.lineTo(10,activeWidth/2); 
			dots[dotNum].s.graphics.endFill();
			
			
			addChild(dots[dotNum].s);
			dotNum++;
		}

		private function enterHandler(e:Event):void
		{
			movedot();
		}
		//mouvement point
		private function movedot():void
		{
			var i:Number,t:Number;
			var a:Number,s:Number,x:Number,y:Number,cx:Number,cy:Number,vx:Number,vy:Number;

			for (i = 0; i<dotNum; i++)
			{
				
				x = dots[i].x;
				y = dots[i].y;
				a = dots[i].angle;
				s = dots[i].v;
				vx = Math.cos(a) * s;
				vy = Math.sin(a) * s;
				x +=  vx;
				y +=  vy;
				
				if (x < 3 || x >= stage.stageWidth - 3 || y < 3 || y >= stage.stageHeight - 3)
				{
					if (x < 3)
					{
						x = 3;
						vx *=  -3;
					}
					if (y > stage.stageWidth - 4)
					{
						y = stage.stageWidth - 4;
						vy *=  -1;
					}
					if (y < 3)
					{
						y = 3;
						vy *=  -1;
					}
					if (y > stage.stageHeight - 4)
					{
						y = stage.stageHeight - 4;
						vy *=  -1;
					}
					dots[i].angle = Math.atan2(vy,vx);
				}
				//position
				dots[i].s.x = dots[i].x = x;
				dots[i].s.y = dots[i].y = y;

				/*if (Math.random() < .1)
				{
					dots[i].angle +=  Math.random() - .5;
				}
				if (Math.random() < .1)
				{
					dots[i].v +=  Math.random() - .5;
					dots[i].v = Math.max(0,Math.min(vitesseMax,Math.abs(dots[i].v)));

				}*/
				if (Math.random() < .1)
				{
					dots[i].v +=  Math.random() - .5;
					dots[i].v = Math.max(0,Math.min(vitesseRotation,Math.sin(dots[i].v)));

				}

			}
			


		}
	}
}